/* aln1r1.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int aln1r1_c(integer *mode, integer *lpivot, integer *l1,
        integer *m, real *u, integer *iue, real *up, real *c__, integer *ice, 
        integer *icv, integer *ncv)
{
    /* Initialized data */

    static doublereal done = 1.;
    static real one = 1.f;
    static real sys056 = 1.175495e-38f; /* = sys055 */

    /* System generated locals */
    integer u_dim1, u_offset, i__1, i__2;
    real r__1, r__2;
    doublereal d__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer incr;
    static doublereal b;
    static integer i__, j;
    static real clinv;
    static integer i2, i3, i4;
    static real cl;
    static doublereal sm;
    static real sm1;


#define u_ref(a_1,a_2) u[(a_2)*u_dim1 + a_1]


/* ********************************************************* */

/*    PURPOSE: */
/*       CONSTRUCTION AND/OR APPLICATION OF A SINGLE */
/*       HOUSEHOLDER TRANSFORMATION */

/*    REFERENCES: */
/*   1. GOLUB G.H., AND VAN LOAN CH.F. MATRIX */
/*      COMPUTATIONS.-JOHNS HOPKINS UNIV.PRESS, 1983 */
/*   2. LAWSON C.L., AND HANSON R.J. SOLVING LEAST SQUARES */
/*      PROBLEMS. - PRENTICE-HALL,INC.,ENGLEWOOD CLIFFS, */
/*      NEW JERSEY, 1974 */

/*    USAGE: */
/*   CALL ALN1R1 (MODE,LPIVOT,L1,M,U,IUE,UP,C,ICE,ICV,NCV) */

/*    PARAMETERS: */

/*    MODE - INTEGER VARIABLE - A CONTROL PARAMETER TO */
/*           SELECT ALGORITHM H1 (CONSTRUCTION AND APPLI- */
/*           CATION OF Q) OR H2 (APPLICATION ONLY) [2]; */
/*  LPIVOT - INTEGER VARIABLE - IS THE INDEX OF PIVOT */
/*           ENTRY LP ; */
/*      L1 - INTEGER VARIABLE - IS DESCRIBED ABOVE; */
/*           IF L1 <= M, THE TRANSFORMATION WILL BE */
/*           CONSTRUCTED TO ZERO ELEMENTS INDEXED FROM L1 */
/*           THROUGH M. IF L1 > M  THE SUBROUTINE DOES */
/*           AN IDENTITY TRANSFORMATION; */
/*      M - INTEGER VARIABLE - THE SIZE OF PROBLEM (THE */
/*          LENGTH OF VECTOR V DESCRIBED ABOVE); */
/*      U - REAL ARRAY OF SIZE IUE BY M - ON ENTRANCE */
/*          TO H1 CONTAINS THE PIVOT VECTOR V WITH THE */
/*          STORAGE INCREMENT IUE BETWEEN ELEMENTS; */
/*          ON EXIT FROM H1 U AND UP CONTAIN QUANTITIES */
/*          DEFINING THE VECTOR U OF THE HOUSEHOLDER */
/*          TRANSFORMATION (SEE (4)); */
/*          ON ENTRY TO H2 U AND UP SHOULD CONTAIN QUANTI- */
/*          TIES PREVIOUSLY COMPUTED BY H1. THESE WILL NOT */
/*          BE MODIFIED BY H2; */
/*   IUE - INTEGER VARIABLE - IS THE STORAGE INCREMENT */
/*         BETWEEN ELEMENTS OF U; */
/*    UP - REAL VARIABLE - ON ENTRANCE TO H1 IS ARBITRARY; */
/*         ON EXIT FROM H1 CONTAINS U(LP) (SEE (4)); */
/*         ON ENTRANCE TO H2 UP SHOULD CONTAIN U(LP) PRE- */
/*         VIOUSLY COMPUTED BY H1 AND WILL NOT CHANGE BY */
/*         H2; */
/*     C - REAL VECTOR OF LENGTH  ICV*NCV  AT LEAST IF */
/*         EL = Q*F MUST BE CALCULATED AND OF LENGTH */
/*         ICE*M  AT LEAST IF  ER = F*Q  MUST BE CALCU- */
/*         LATED  -  ON ENTRY TO H1 OR H2  C  CONTAINS A */
/*         MATRIX WHICH BE REGARDED AS A SET OF VECTORS */
/*         TO WHICH THE HOUSEHOLDER TRANSFORMATION IS TO */
/*         BE APPLIED. ON EXIT  C  CONTAINS THE SET OF */
/*         TRANSFORMED VECTORS; */
/*   ICE - INTEGER VARIABLE - STORAGE INCREMENT BETWEEN */
/*         ELEMENTS OF VECTORS IN C; */
/*   ICV - INTEGER VARIABLE - STORAGE INCREMENT BETWEEN */
/*         VECTORS IN  C; */
/*   NCV - INTEGER VARIABLE - NUMBER OF VECTORS IN  C  TO */
/*         BE TRANSFORMED. IF  NCV <= 0 NO OPERATIONS */
/*         WILL BE DONE ON  C . */

/* ********************************************************* */

    /* Parameter adjustments */
    u_dim1 = *iue;
    u_offset = u_dim1 + 1;
    u -= u_offset;
    --c__;

    /* Function Body */

/*       SYS056 IS INVERSE VALUE OF MAXIMAL REAL TYPE */
/*       NUMBER WHICH MAY BE REPRESENTED AT THE IBM PC . */

    if (0 >= *lpivot || *lpivot >= *l1 || *l1 > *m) {
        goto L170;
    }
    cl = (r__1 = u_ref(1, *lpivot), abs(r__1));
    if (*mode == 2) {
        goto L100;
    }

/*     .....CONSTRUCT THE TRANSFORMATION......... */

    i__1 = *m;
    for (j = *l1; j <= i__1; ++j) {
/* L10: */
/* Computing MAX */
        r__2 = (r__1 = u_ref(1, j), abs(r__1));
        cl = max(r__2,cl);
    }
    if (cl <= 0.f) {
        goto L170;
    } else {
        goto L20;
    }
L20:
    if (cl - sys056 <= 0.f) {
        goto L30;
    } else {
        goto L50;
    }
L30:
/* Computing 2nd power */
    d__1 = (doublereal) u_ref(1, *lpivot) / cl;
    sm = d__1 * d__1;
    i__1 = *m;
    for (j = *l1; j <= i__1; ++j) {
/* L40: */
/* Computing 2nd power */
        d__1 = (doublereal) u_ref(1, j) / cl;
        sm += d__1 * d__1;
    }
    goto L70;
L50:
    clinv = one / cl;
/* Computing 2nd power */
    d__1 = (doublereal) u_ref(1, *lpivot) * clinv;
    sm = d__1 * d__1;
    i__1 = *m;
    for (j = *l1; j <= i__1; ++j) {
/* L60: */
/* Computing 2nd power */
        d__1 = (doublereal) u_ref(1, j) * clinv;
        sm += d__1 * d__1;
    }

/*     CONVERT DOUBLE PRECISION .SM. */
/*     TO SINGLE PRECISION .SM1. */

L70:
    sm1 = (real) sqrt(sm);
    cl *= sm1;
    if (u_ref(1, *lpivot) <= 0.f) {
        goto L90;
    } else {
        goto L80;
    }
L80:
    cl = -cl;
L90:
    *up = u_ref(1, *lpivot) - cl;
    u_ref(1, *lpivot) = cl;
    goto L110;

/*     APPLY THE TRANSFORMATION  1+U*TRANSPOSE(U)/B TO C* */

L100:
    if (cl <= 0.f) {
        goto L170;
    } else {
        goto L110;
    }
L110:
    if (*ncv <= 0) {
        goto L170;
    }
    b = (doublereal) (*up) * u_ref(1, *lpivot);

/*     B MUST BE NONPOSITIVE HERE. IF B=0. RETURN */

    if (b >= 0.) {
        goto L170;
    } else {
        goto L120;
    }
L120:
    b = done / b;
    i2 = 1 - *icv + *ice * (*lpivot - 1);
    incr = *ice * (*l1 - *lpivot);
    i__1 = *ncv;
    for (j = 1; j <= i__1; ++j) {
        i2 += *icv;
        i3 = i2 + incr;
        i4 = i3;
        sm = c__[i2] * (doublereal) (*up);
        i__2 = *m;
        for (i__ = *l1; i__ <= i__2; ++i__) {
            sm += c__[i3] * (doublereal) u_ref(1, i__);
/* L130: */
            i3 += *ice;
        }
        if (sm != 0.) {
            goto L140;
        } else {
            goto L160;
        }
L140:
        sm *= b;
        c__[i2] += sm * (doublereal) (*up);
        i__2 = *m;
        for (i__ = *l1; i__ <= i__2; ++i__) {
            c__[i4] += sm * (doublereal) u_ref(1, i__);
/* L150: */
            i4 += *ice;
        }
L160:
        ;
    }
L170:
    return 0;
} /* aln1r1_c */

#undef u_ref
